> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cognigy.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Inject and Notify API

The *Inject* and *Notify* API requests handle external processes that need to communicate back to an active session in Cognigy.AI. You can use these API requests when an AI Agent needs to run external processes, for example, document analysis, outside of Cognigy.AI before continuing the conversation. After the external process has concluded, it needs to trigger Cognigy.AI.

## Limitations

<Warning>
  As of April 2025, the AudioCodes Endpoint is deprecated. The full removal of the AudioCodes Endpoint is planned for Q2 2026. Migrate to the [Voice Gateway Endpoint](/ai/agents/deploy/endpoint-reference/voice-gateway) before the removal date.
</Warning>

Only the following Endpoints support the inject and notify API requests:

* [Facebook (Meta) Messenger](/ai/agents/deploy/endpoint-reference/facebook-messenger)
* [LINE Messenger](/ai/agents/deploy/endpoint-reference/line-messenger)
* [Azure Bot Services](/ai/agents/deploy/endpoint-reference/azure-bot-services)
* [RingCentral Engage](/ai/agents/deploy/endpoint-reference/ringcentral-engage)
* [Slack](/ai/agents/deploy/endpoint-reference/slack)
* [Socket](/ai/agents/deploy/endpoint-reference/socketio)
* [Sunshine Conversations](/ai/agents/deploy/endpoint-reference/sunshine-conversations)
* [Voice Gateway](/ai/agents/deploy/endpoint-reference/voice-gateway)
* [AudioCodes](/ai/agents/deploy/endpoint-reference/audiocodes)
* [WhatsApp](/ai/agents/deploy/endpoint-reference/whatsapp)
* [Webchat](/ai/agents/deploy/endpoint-reference/webchat)
* [Webhook](/ai/agents/deploy/endpoint-reference/webhook)

## Inject

An inject API request sends text and data from an external service to a Flow. This approach allows you to convert them into complex information, for example, into lists and galleries, and then send it to the user through the Endpoint. You can send a simple message to your Flow, for example, `makeList`, along with the data from an external API request, and use the Nodes in the Flow to recognize the message and send a list to the user with information from an external API.

## Notify

A notify API request sends text or data to the user through the Endpoint. With this approach, the user receives the text or data from the external API without any additional Flow logic.

## How to Use Inject and Notify

You can use the [HTTP Request Node](/ai/agents/develop/node-reference/service/http-request) or [Code Node](/ai/for-developers/code/overview) to trigger external processes through the Cognigy.AI API and pass the necessary data to the inject and notify API requests in addition to the specific external payload.

### Inject and Notify API URLs

For the inject and notify API methods, use the Endpoint service for the API URL. You can find your Endpoint URL and URL token in the [Endpoint settings](/ai/agents/deploy/endpoints/overview) under the **Endpoint URL** field or **Config URL** field, for Webchat Endpoints. The API routes are:

* Notify: `{EndpointURL}/notify/{URLToken}`
* Inject: `{EndpointURL}/inject/{URLToken}`

For example, if your Endpoint URL is `https://endpoint-trial.cognigy.ai/4e5e2f01110c935fff81ec54bbce12c175b831d8105dc69face36a8983feec17`, the base URL is `https://endpoint-trial.cognigy.ai` and URL token is `4e5e2f01110c935fff81ec54bbce12c175b831d8105dc69face36a8983feec17`. In this case, the API routes are:

* Notify: `https://endpoint-trial.cognigy.ai/notify/4e5e2f01110c935fff81ec54bbce12c175b831d8105dc69face36a8983feec17`
* Inject: `https://endpoint-trial.cognigy.ai/inject/4e5e2f01110c935fff81ec54bbce12c175b831d8105dc69face36a8983feec17`

### Payload

You can retrieve the necessary data for the inject and notify payload from the [Input object](/ai/agents/develop/ai-agent-memory/input) with [CognigyScript](/ai/platform-features/cognigyscript), as follows:

| Payload Parameter | CognigyScript |
| ----------------- | ------------- |
| text              | ci.text       |
| data              | ci.data       |
| sessionId         | ci.sessionId  |
| userId            | ci.userId     |
| URLToken          | ci.URLToken   |

## Inject and Notify in Transformers

There are cases where you don't have control over the payload that the external process sends to the inject or notify API requests. In these cases, you can use the [inject](/ai/for-developers/transformers/inject-transformer) or [notify](/ai/for-developers/transformers/notify-transformer) transformers to change the request and extract the necessary parameters from the request body before calling the actual notify or inject API.

## More Information

* [Inject Transformer](/ai/for-developers/transformers/inject-transformer)
* [Notify Transformer](/ai/for-developers/transformers/notify-transformer)
